#ifndef __CF_BUTTON_H__
#define __CF_BUTTON_H__

#include <Gui/CFBin.h>

CF_NAMESPACE_BEGIN

class CFButton : public CFBin {
public:
    CFButton();
    CFButton(const Glib::ustring& label, bool mnemonic = false);

    virtual ~CFButton();

    void setRelief(CFReliefStyle newstyle);
    CFReliefStyle getRelief();

    void setLabel(const Glib::ustring& label);
    Glib::ustring getLabel();

    sigc::signal< void > signalPressed();
    sigc::signal< void > signalReleased();
    sigc::signal< void > signalClicked();
    sigc::signal< void > signalEnter();
    sigc::signal< void > signalLeave();
    sigc::signal< void > signalActivate();

protected:
    virtual void onRealObjectInit();
    virtual void onRealObjectFinalize();

    virtual void onPressed();
    virtual void onReleased();
    virtual void onClicked();
    virtual void onEnter();
    virtual void onLeave();
    virtual void onActivate();

private:
    sigc::signal< void > m_pressedSignal;
    sigc::signal< void > m_releasedSignal;
    sigc::signal< void > m_clickedSignal;
    sigc::signal< void > m_enterSignal;
    sigc::signal< void > m_leaveSignal;
    sigc::signal< void > m_activateSignal;
};

CF_NAMESPACE_END

#endif  // __CF_BUTTON_H__