#ifndef __CF_CONTAINER_H__
#define __CF_CONTAINER_H__

#include <Gui/CFWidget.h>
#include <Core/CFTypes.h>

CF_NAMESPACE_BEGIN

class CFContainerPriv;
class CFContainer : public CFWidget {
    friend class CFContainerPriv;

public:
    typedef sigc::slot<void, CFWidget*> ForeachSlot;

    virtual ~CFContainer();

    virtual void add(CFWidget& widget);
    virtual void remove(CFWidget& widget);

    void foreach(ForeachSlot slot);
    void forall(ForeachSlot slot);

    bool isContainer();

    virtual void addCssStylePath(const Glib::ustring& path, CFUInt priority);
    virtual void addCssStyleData(const Glib::ustring& data, CFUInt priority);

protected:
    CFContainer();

    void onApplyCssPath(CFWidget* widget);
    void onApplyCssData(CFWidget* widget);

private:
    sigc::signal<void, CFWidget*> signalForeach();

private:
    sigc::signal<void, CFWidget*> m_foreachSignal;
    CFContainerPriv* m_priv;

    Glib::ustring m_cssStylePath;
    Glib::ustring m_cssStyleData;
    CFUInt m_cssStylePriority;
};

CF_NAMESPACE_END

#endif  // __CF_CONTAINER_H__
