#ifndef __CF_ENTRY_H__
#define __CF_ENTRY_H__

#include <Gui/CFWidget.h>

CF_NAMESPACE_BEGIN

class CFEntry : public CFWidget {
public:
    CFEntry();
    virtual ~CFEntry();

    void setVisibility(bool visible=true);
    bool getVisibility();

    void setInvisibleChar(char ch);
    void unsetInvisibleChar();
    char getInvisibleChar();

    void setPlaceholderText(const Glib::ustring& text);
    void setText(const Glib::ustring& text);
    Glib::ustring getText();

    sigc::signal< void > signalActivate();

protected:

    virtual void onRealObjectInit();

    virtual void onActivate();

private:
    sigc::signal< void > m_activateSignal;
};

CF_NAMESPACE_END

#endif // __CF_ENTRY_H__