#ifndef __CF_IMAGE_BUTTON_H__
#define __CF_IMAGE_BUTTON_H__

#include <Gui/CFDrawingArea.h>
#include <Gui/CFStateImage.h>

CF_NAMESPACE_BEGIN

class CFImageButton : public CFDrawingArea {
public:
    explicit CFImageButton();

    void setStateImage(const StateImage& stImage);
    void setCornerRadius(uint32_t radius);

    sigc::signal<void> signalClicked();

private:
    bool onImageButtonRealDraw(const ::Cairo::RefPtr<::Cairo::Context>& cr);
    bool onEventReceived(GdkEvent* event);
    bool checkPointInside(int x, int y);

private:
    StateImage m_stImage;
    StateImage::State m_currentSt;
    sigc::signal<void> m_clickedSignal;
    uint32_t m_cornerRadius;
    uint32_t m_realCornerRd;
    int m_realWidth;
    int m_realHeight;
};

CF_NAMESPACE_END

#endif  // __CF_IMAGE_BUTTON_H__