#ifndef __CF_LABLE_H__
#define __CF_LABLE_H__

#include <Gui/CFMisc.h>
#include <pangomm.h>

CF_NAMESPACE_BEGIN

class CFLabel : public CFMisc {
public:
    CFLabel();
    CFLabel(const Glib::ustring& label, bool mnemonic = false);
    CFLabel(const Glib::ustring& label,
            float xalign,
            float yalign,
            bool mnemonic = false);
    CFLabel(const Glib::ustring& label,
            CFAlign xalign,
            CFAlign yalign = CFALIGN_CENTER,
            bool mnemonic = false);

    virtual ~CFLabel();

    void setText(const Glib::ustring& str);
    Glib::ustring getText();

    void setLabel(const Glib::ustring& str);
    Glib::ustring getLabel();

    void setMarkup(const Glib::ustring& str);

    void setUseMarkup(bool setting = true);

    void setEllipsize(Pango::EllipsizeMode mode);

    void setJustify(CFJustification type);
    CFJustification getJustify();

    void setLineWrap(bool wrap = true);
    void setLineWrapMode(Pango::WrapMode wrap_mode);
    void setLines(int lines);
};

CF_NAMESPACE_END

#endif  // __CF_LABLE_H__
