#ifndef __CF_MAIN_H__
#define __CF_MAIN_H__

#include <Core/CFDefines.h>
#include <Core/CFObject.h>
#include <Gui/CFWindow.h>
#include <glibmm/optioncontext.h>

CF_NAMESPACE_BEGIN

class CFMain : public CFObject {
public:
    CFMain(int& argc, char**& argv, Glib::OptionContext& option_context);
    CFMain(int* argc, char*** argv, bool set_locale = true);
    CFMain(int& argc, char**& argv, bool set_locale = true);
    CFMain(bool set_locale = true);

    virtual ~CFMain();

public:
    static void run();
    static void run(CFWindow& window);
    static void quit();

    static void addGtkOptionGroup(Glib::OptionContext& option_context,
                                  bool open_default_display = true);
};

CF_NAMESPACE_END

#endif  // __CF_MAIN_H__
