#ifndef __CF_MENU_H__
#define __CF_MENU_H__

#include <Gui/CFMenuShell.h>
#include <gdkmm.h>
#include <giomm.h>

CF_NAMESPACE_BEGIN

class CFMenu : public CFMenuShell {
public:
    typedef sigc::slot<void, int&, int&, bool&> SlotPositionCalc;
    CFMenu();
    CFMenu(const Glib::RefPtr<Gio::MenuModel>& model);

    void popup(CFMenuShell& parent_menu_shell,
               CFMenuItem& parent_menu_item,
               const SlotPositionCalc& slot,
               CFUInt button,
               CFUInt32 activate_time,
               const Glib::RefPtr<Gdk::Device>& device
               = Glib::RefPtr<Gdk::Device>());

    void popup(const SlotPositionCalc& position_calc_slot,
               CFUInt button,
               CFUInt32 activate_time,
               const Glib::RefPtr<Gdk::Device>& device
               = Glib::RefPtr<Gdk::Device>());

    void popup(CFUInt button,
               CFUInt32 activate_time,
               const Glib::RefPtr<Gdk::Device>& device
               = Glib::RefPtr<Gdk::Device>());

    void popupAtWidget(CFWidget* widget,
                       Gdk::Gravity widget_anchor,
                       Gdk::Gravity menu_anchor,
                       const GdkEvent* trigger_event);

    void popupAtPointer(const GdkEvent* trigger_event);

    void reposition();

    void popdown();

    CFMenuItem* getActive();

    void setActive(CFUInt index);

    void setAccelPath(const Glib::ustring& accel_path);

    Glib::ustring getAccelPath();

    void detach();

    CFWidget* getAttachWidget();

    void setTearoffState(bool torn_off = true);

    bool getTearoffState();

    void setTitle(const Glib::ustring& title);

    void unsetTitle();

    Glib::ustring getTitle();

    void setScreen(const Glib::RefPtr<Gdk::Screen>& screen);

    void attach(CFWidget& child,
                CFUInt left_attach,
                CFUInt right_attach,
                CFUInt top_attach,
                CFUInt bottom_attach);

    void setMonitor(int monitor_num);

    int getMonitor();

    void reorderChild(CFMenuItem& child, int position);

    void setReserveToggleSize(bool reserve_toggle_size = true);

    bool getReserveToggleSize();

    void attachToWidget(CFWidget& attach_widget);
};

CF_NAMESPACE_END

#endif  // __CF_MENU_H__
