// Copyright 2017, CDOS.
// All rights reserved.
//
// Author: CDOS Support Team <support_os@sari.ac.cn>
//
// A choice from multiple check buttons.
#ifndef __CF_RADIOBUTTON_H__
#define __CF_RADIOBUTTON_H__

#include "Gui/CFCheckButton.h"

CF_NAMESPACE_BEGIN

class CFRadioButton : public CFCheckButton {
public:
    explicit CFRadioButton();

    CFRadioButton(const Glib::ustring& label, bool mnemonic = false);

    virtual ~CFRadioButton();

    void resetGroup();

    void joinGroup(CFRadioButton& group_source);

    sigc::signal<void> signalGroupChanged();

protected:
    virtual void onRealObjectInit();

    virtual void onRealObjectFinalize();

    void onGroupChanged();

private:
    sigc::signal<void> m_groupChangedSignal;
};

CF_NAMESPACE_END

#endif  // __CF_RADIOBUTTON_H__
