// Copyright 2017, CDOS.
// All rights reserved.
//
// Author: CDOS Support Team <support_os@sari.ac.cn>
//
// Adds scrollbars to its child widget.
#ifndef __CF_SCROLLEDVIEW_H__
#define __CF_SCROLLEDVIEW_H__

#include <Gui/CFBin.h>
#include <Gui/CFAdjustment.h>
#include "Gui/CFScrollbar.h"
#include "Gui/CFEnums.h"

CF_NAMESPACE_BEGIN

class CFScrolledViewPriv;

class CFScrolledView : public CFBin {
public:
    CFScrolledView();

    virtual ~CFScrolledView();

    // CFScrolledView(CFAdjustment& hadjustment, CFAdjustment& vadjustment);

    // void setHadjustment(CFAdjustment& hadjustment);

    // CFAdjustment getHajustment();

    // void setVadjustment(CFAdjustment& vhadjustment);

    // CFAdjustment getVajustment();

    void setPolicy(CFPolicyType hscrollbar_pollcy,
                   CFPolicyType vscrollbar_pollcy);

    void getPolicy(CFPolicyType& hscrollbar_pollcy,
                   CFPolicyType& vscrollbar_pollcy);

    void setPlacement(CFCornerType window_placement);

    void unsetPlacement();

    CFCornerType getPlacement();

    void setShadowType(CFShadowType type);

    CFShadowType getShadowType();

    void add(CFWidget& widget);  // override Cdos::CFConter::add

    void removeWithViewport();

    CFScrollbar* getVscrollbar();

    CFScrollbar* setHscrollbar();

    int getMinContentWidth();

    void setMinContentWidth(int width);

    int getMinContentHeight();

    void setMinContentHeight(int height);

    void setKineticScrolling(bool kinetic_scrolling = true);

    bool getKineticScrolling();

    void setCaptureButtonPress(bool capture_button_press);

    bool getCaptureButtonPress();

    void setOverlayScrolling(bool overlay_scrolling);

    bool getOverlayScrolling();

    void setMaxContentWidth(int width);

    int getMaxContentWidth();

    void setMaxContentHeight(int height);

    int getMaxContentHeight();

    void setPropagateNaturalWidth(bool propagate = true);

    bool getPropagateNaturalWidth();

    void setPropagateNaturalHeight(bool propagate = true);

    bool getPropagateNaturalHeight();

    sigc::signal<void, CFPositionType> signalEdgeOvershot();

    sigc::signal<void, CFPositionType> signalEdgeReached();

protected:
    virtual void onRealObjectInit();

    virtual void onRealObjectFinalize();

private:
    sigc::signal<void, CFPositionType> m_edgeOvershotSignal;

    sigc::signal<void, CFPositionType> m_edgeReachedSignal;

    CFScrolledViewPriv* m_priv;
};

CF_NAMESPACE_END
#endif  // __CF_SCROLLEDVIEW_H__
