// Copyright 2017, CDOS.
// All rights reserved.
//
// Author: CDOS Support Team <support_os@sari.ac.cn>
//
// A "light switch"-style toggle.

#ifndef __CF_SWITCH_H__
#define __CF_SWITCH_H__

#include "Gui/CFWidget.h"

CF_NAMESPACE_BEGIN

class CFSwitch : public CFWidget {
public:
    CFSwitch();

    virtual ~CFSwitch();

    void setActive(bool is_active = true);

    bool getActive();

    void setState(bool state = true);

    bool getState();

    sigc::signal<bool, bool> signalStateSet();

protected:
    virtual void onRealObjectInit();

    virtual void onRealObjectFinalize();

    bool onStateSet(bool state);

private:
    sigc::signal<bool, bool> m_stateSetSignal;
};

CF_NAMESPACE_END
#endif  // __CF_SWITCH_H__
