#ifndef __CF_USERFACE_H__
#define __CF_USERFACE_H__

#include <Gui/CFDrawingArea.h>
#include <Gui/CFStateImage.h>
#include <sigc++/sigc++.h>

CF_NAMESPACE_BEGIN

class CFUserFace : public CFDrawingArea {
public:
    explicit CFUserFace();

    void setStateImage(const StateImage& stImage);

private:
    bool onUserFaceRealDraw(const ::Cairo::RefPtr<::Cairo::Context>& cr);
    bool onEventReceived(GdkEvent* event);
    bool checkPointInside(int x, int y);

private:
    StateImage m_stImage;
    StateImage::State m_currentSt;
    sigc::signal<bool, GdkEvent*> m_userFacePressed;
};

CF_NAMESPACE_END

#endif  // __CF_USERFACE_H__