#ifndef __CFDATE_H__
#define __CFDATE_H__

#include <Core/CFTypes.h>

class CFDate {
public:
    CFDate(CFInt y, CFInt m, CFInt d);
    CFDate();

    void setYear(CFInt y);
    void setMonth(CFInt m);
    void setDayOfMonth(CFInt d);

    CFInt getYear();
    CFInt getMonth();
    CFInt getDayOfMonth();

    CFWeek getWeekDay();
    CFInt getDayOfYear();

private:
    bool isValidYear(CFInt y);
    bool isValidMonth(CFInt m);
    bool isValidDay(CFInt y, CFInt m, CFInt d);
    bool isLeap(CFInt y);

    void reCalcWeekDay();
    CFInt countYearByModBet(CFInt nYearS, CFInt nYearE, CFInt nBet);
    CFInt countLeapYear(CFInt nYearS, CFInt nYearE);
    CFWeek calcWeekDay(CFInt y, CFInt m, CFInt d);

private:
    CFInt m_year;
    CFInt m_month;
    CFInt m_dayOfMonth;
    CFWeek m_dayOfWeek;
};

#endif // __CFDATE_H__